function x = jacobi(A, b, x, nsteps, weight) 
%% (weighted) Jacobi iteration
%
if nargin < 5
    weight = 2/3;
end


if nsteps > 0
    
    %M = diag(diag(A));
    M = (diag(A));
    %N = A - M;
    
    for its = 1:nsteps
        %x = M \ (b - N*x);
        %x = (1-weight) *x + weight * (x + M \ (b - A*x));
        %x = x + weight * (M \ (b - A*x));
        x = x + weight * ((b - A*x) ./ M);
    end
end

end
